small fixes, add maru script
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/repos/bash/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd ian; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { treetowl || x2 || frodo || tp || demohost; }
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
159 # and you have no idea why.
160 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
161 selinuxenabled && sudo setenforce 0
162 fi
163
164
165 # already ran for pxe installs, but used for vps & updates
166 distro=$(distro-name)
167 case $distro in
168 ubuntu|debian)
169 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
170 ;;
171 *)
172 sudo bash -c ". /a/bin/fai/fai-wrapper &&
173 /a/bin/fai/fai/config/distro-install-common/end"
174 ;;
175 esac
176
177 if linode; then
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.lan $HOSTNAME" | sudo tee -a /etc/hosts
180 fi
181
182
183 if [[ $EUID == 0 ]]; then
184 echo "$0: running as root. exiting now that users are setup"
185 exit 0
186 fi
187
188
189 # this needs to be before installing pacserve so we have gpg conf.
190 conflink
191
192 set +x
193 errallow
194 source ~/.bashrc
195 $interactive || errcatch
196 $interactive || set -x
197
198
199 # passwordless sudo
200 tu /etc/sudoers <<'EOF'
201 ian ALL=(ALL) NOPASSWD: ALL
202 Defaults env_keep += SUDOD
203 EOF
204
205
206 # enable magic sysrq keys. debian docs say it is already enabled by default
207 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
208
209
210 if isdebian; then
211 codename=$(debian-codename)
212 if isdebian-stable && has_x; then
213 s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
214 deb http://mozilla.debian.net/ $codename-backports firefox-release
215 deb-src http://mozilla.debian.net/ $codename-backports firefox-release
216 EOF
217 p update
218 # take care of mozilla signing errors in previous command
219 pi pkg-mozilla-archive-keyring
220 p update
221 else
222 :
223 # this would change stable to testing, but I set that up already.
224 # It\'s just a no-op if its already testing.
225 # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
226 p update
227 fi
228 fi
229
230 if isarch; then
231 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
232 sudo pacman -S --noconfirm --needed base-devel jq
233 # pacaur seems to be the best, although it + cower has a few minor bugs,
234 # its design goals seem good, so, going for it.
235
236 aurpi() {
237 for p in "$@"; do
238 tempdir=$(mktemp -d)
239 pushd $tempdir
240 aurex "$p"
241 makepkg -sri --skippgpcheck --noconfirm
242 popd
243 rm -rf $tempdir
244 done
245 }
246 aurpi cower pacaur
247
248 pi pacserve
249
250 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
251 sudo dd of=/etc/pacman.conf if=$x; rm $x
252 sudo systemctl enable pacserve.service
253 sudo systemctl start pacserve.service
254
255 # strange error if just installing trash-cli: "pyalpm requires python",
256 # so I see that it requires python2, and installing that manually fixes it.
257 # I didn't see this on earlier installation, main thing which changed was
258 # pacserve, so not sure if it's related.
259 pi python2
260 fi
261
262 pup
263 pi trash-cli
264
265
266 ###### link files ###########
267 # convenient to just do all file linking in one place
268
269 # if it wasn't set already, we could set hostname here
270 #echo treetowl | s dd of=/etc/hostname
271 #s hostname -F /etc/hostname
272 #HOSTNAME=$(hostname)
273
274
275 s lnf -T /a/bin /b
276
277 if has_p; then
278 lnf -T /p/News ~/News
279 fi
280
281 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
282 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
283
284 rootsshsync
285
286 s lnf /a/c/.inputrc /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
287
288 # machine is going away
289 # if [[ $HOSTNAME == htpc ]]; then
290 # lnf -T /i/Videos ~/Downloads
291 # fi
292
293 if has_p; then
294 # for dovecot
295 lnf -T /i/k/mboxes ~/mail
296 fi
297
298
299 # basic needed packages
300 case $(distro-name) in
301 debian)
302 if has_x; then
303 if isdebian-stable; then
304 pi firefox/$codename-backports
305 else
306 # for a while, firefox/unstable did not have
307 # dependencies satisfied by testing packages, and i hit
308 # a conflict, it wanted a newer libfontconfig1, but
309 # emacs build-deps wanted an older one. In this case,
310 # I switch to using firefox-esr. note: They seem
311 # to release a new esr version every 9 months or so.
312 pi firefox/unstable
313 fi
314 fi
315 # for hosts which require nonfree drivers
316 # i previously had extra packages listed here linux-image-amd64
317 # firmware-linux-free linux-headers-amd64, but I
318 # don\'t see any reason why. seems to work in testing without.
319 # remove this note if it continues to work.
320 p=firmware-linux-nonfree
321 if apt-cache show $p &>/dev/null; then
322 pi $p
323 fi
324 ;;&
325 ubuntu|debian)
326 if has_x; then
327 if isdebian-stable; then
328 pi xmacro
329 else
330 pi xmacro/unstable # has no unstable deps
331 fi
332 pi gtk-redshift xinput
333 fi
334 ;;&
335 fedora)
336 p -y groupinstall development-tools c-development books admin-tools
337 pi wget man-pages
338 if has_x; then
339 pi redshift-gtk
340 # debian has this package patched to work, upstream is dead
341 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
342 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
343 # http://packages.debian.org/source/sid/xmacro
344 pi patch libXtst-devel
345 cd $(mktemp -d)
346 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
347 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
348 ex *.gz
349 patch -p0 < xmacro_0.3pre-20000911-6.diff
350 cd xmacro-0.3pre-20000911.orig
351 make
352 sleep 1 # not sure why the following command couldn\'t find, so trying this
353 # no make install target
354 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
355 fi
356 ;;&
357 arch)
358 # like apt-cache
359 pi pkgfile
360 s pkgfile --update
361 if has_x; then
362 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
363 pi xorg-server redshift xorg-xinput libxtst xmacro
364
365 # background:
366 # https://aur.archlinux.org/packages/xkbset/#comment-545419
367 cert=$(mktemp)
368 cat >$cert <<'EOF'
369 -----BEGIN CERTIFICATE-----
370 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
371 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
372 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
373 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
374 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
375 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
376 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
377 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
378 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
379 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
380 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
381 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
382 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
383 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
384 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
385 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
386 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
387 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
388 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
389 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
390 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
391 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
392 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
393 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
394 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
395 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
396 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
397 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
398 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
399 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
400 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
401 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
402 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
403 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
404 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
405 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
406 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
407 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
408 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
409 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
410 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
411 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
412 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
413 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
414 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
415 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
416 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
417 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
418 lzGQzw==
419 -----END CERTIFICATE-----
420 -----BEGIN CERTIFICATE-----
421 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
422 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
423 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
424 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
425 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
426 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
427 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
428 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
429 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
430 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
431 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
432 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
433 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
434 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
435 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
436 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
437 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
438 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
439 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
440 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
441 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
442 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
443 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
444 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
445 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
446 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
447 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
448 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
449 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
450 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
451 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
452 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
453 -----END CERTIFICATE-----
454 -----BEGIN CERTIFICATE-----
455 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
456 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
457 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
458 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
459 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
460 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
461 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
462 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
463 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
464 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
465 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
466 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
467 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
468 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
469 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
470 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
471 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
472 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
473 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
474 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
475 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
476 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
477 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
478 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
479 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
480 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
481 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
482 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
483 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
484 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
485 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
486 jjxDah2nGN59PRbxYvnKkKj9
487 -----END CERTIFICATE-----
488 EOF
489 cat /etc/ssl/certs/ca-certificates.crt >> $cert
490 CURL_CA_BUNDLE=$cert pi xkbset
491 fi
492
493 ;;&
494 ubuntu|debian|fedora)
495 if has_x; then
496 if isdebian-stable; then
497 pi xkbset
498 else
499 # xkbset was in testing for quite a while, dunno
500 # why it\'s not anymore. Sometime I should check and
501 # see if it\'s back in testing, but the unstable package
502 # doesn\'t upgrade anything form testing, and it\'s tiny
503 # so I\'m not bothering to automate it.
504 pi xkbset/unstable
505 fi
506 fi
507 ;;&
508 esac
509
510 if has_x; then
511 pi xbindkeys
512 fi
513 pi cryptsetup lvm2
514 # enables trim for volume delete, other rare commands.
515 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
516
517 if encrypted; then
518 if isdeb; then
519 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
520 fi
521 # does weekly trim
522 sudo systemctl enable fstrim.timer
523 fi
524
525 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
526 s mkdir -p "${dirs[@]}"
527 s chown ian:ian "${dirs[@]}"
528
529
530 tu /etc/fstab <<'EOF'
531 /i/w /w none bind,noauto 0 0
532 /i/k /k none bind,noauto 0 0
533 EOF
534
535
536 if ! mountpoint /kr; then
537 s mkdir -p /kr
538 s chown ian:traci /kr
539 fi
540
541 if home_network; then
542 if [[ $HOSTNAME == treetowl ]]; then
543 tu /etc/fstab <<'EOF'
544 /k /kr none bind,noauto 0 0
545 EOF
546 else
547 tu /etc/fstab <<'EOF'
548 treetowl:/k /kr nfs noauto 0 0
549 EOF
550 fi
551 fi
552
553 s mkdir -p /q /i/{w,k}
554 for dir in /{i,w,k}; do
555 if mountpoint $dir; then continue; fi # already mounted
556 s mkdir -p $dir
557 s chown ian:ian $dir
558 done
559
560 # not needed for all hosts, but rather just keep it uniform
561 s mkdir -p /mnt/iroot
562
563 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
564 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
565 # based on 3 of those, it creates .device units for /dev/mapper/dev...
566 # then waits endlessly for them on bootup, after the /dev/mapper disks
567 # have already been created and exist. todo: create a simple repro
568 # for this in a vm and report it upstream.
569 if has_btrfs || home_network; then
570 pi nfs-common
571 s dd of=/root/imount <<'EOF'
572 #!/bin/bash
573 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
574 set -eE -o pipefail
575 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
576 for dir in /i /mnt/iroot /k /kr /w; do
577 if ! mountpoint $dir &>/dev/null && \
578 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
579 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
580 mount $dir || echo "warning: failed to mount nfs on $dir"
581 else
582 mount $dir
583 fi
584 fi
585 done
586 EOF
587 s chmod +x /root/imount
588
589 s dd of=/etc/systemd/system/imount.service <<'EOF'
590 [Unit]
591 Description=Mount /i and related mountpoints
592
593 [Service]
594 Type=oneshot
595 ExecStart=/root/imount
596
597 [Install]
598 # note /kr needs networking, this target is the simplest way to
599 # time it when the network should be up, but not do something
600 # dumb like delay startup until the network is up. It happens
601 # at some time after network.target
602 WantedBy=multi-user.target
603 EOF
604 sudo systemctl daemon-reload # needed if the file was already there
605 sudo systemctl enable imount.service
606 sudo systemctl start imount.service
607 fi
608
609 dir=/nocow
610 if has_btrfs; then
611 if ! mountpoint $dir; then
612 subvol=/mnt/root/nocow
613 if [[ ! -e $subvol ]]; then
614 s btrfs subvolume create $subvol
615 s chown root:1000 $subvol
616 s chattr +C $subvol
617 fi
618
619 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
620 tu /etc/fstab <<EOF
621 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
622 EOF
623 s mkdir -p $dir
624 s chown ian:ian $dir
625 s mount $dir
626 fi
627 else
628 sudo mkdir -p $dir
629 fi
630
631 # ssh and probably some other things care about parent directory
632 # ownership, and ssh doesn\'t allow any group writable parent
633 # directories, so we are forced to use a directory structure similar
634 # to home directories
635 s chown root:ian /q
636 s chmod 755 /q
637
638
639 # it comes with stretch and arch, but not jessie.
640 # propogate /etc/udev/hwdb.d
641 if which systemd-hwdb; then
642 s systemd-hwdb update
643 ser restart systemd-udev-trigger
644 fi
645
646
647 if isdeb; then
648 # I\'ve had problems with postfix on debian:
649 # on stretch, a startup ordering issue caused all mail to fail.
650 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
651 # exim4 is default on debian, so I assume it would
652 # be packaged better to avoid these types of things.
653 # I haven\'t gotten around to getting a non-debian exim
654 # setup.
655 mail-setup exim4
656 else
657 mail-setup postfix
658 fi
659
660 if isubuntu; then
661 # disable crash report annoying crap
662 s dd of=/etc/default/apport <<<'enabled=0'
663 fi
664
665 # fai sets this an old way that doesn't work for stretch.
666 # no harm in setting it universally here.
667 # using debconf-set-selection, the area gets reset to ETC
668 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
669 # so we are using expect :(
670 # I got a random error when running this, so I added a sleep
671 # rather than trying to write a whole detect and wait loop.
672 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
673 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
674 sleep 1
675 s apt-get -y install --no-install-recommends expect
676 s expect <<EOF
677 set force_conservative 0
678 spawn dpkg-reconfigure tzdata -freadline
679 expect -nocase timeout {exit 1} "Geographic area:"
680 send "12\r"
681 expect -nocase timeout {exit 1} "Time zone:"
682 send "11\r"
683 expect eof
684 exit
685 EOF
686
687
688 if has_x; then
689 if isarch; then
690 # install so it's build dependencies don't get removed.
691
692 # emacs git build is currently broken
693 if false; then
694 x=$(mktemp -d)
695 pushd $x
696 aurex emacs-git
697 makepkg -si --noconfirm
698 popd
699 rm -rf $x
700 else
701 pi emacs
702 fi
703 pi hunspell hunspell-en
704 else
705 if $recompile; then
706 /a/bin/buildscripts/emacs
707 else
708 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
709 fi
710 fi
711
712 # todo, figure this out for arch if we ever try out gnome.
713 if ! isarch; then
714 # install for multiple display managers in case we use one
715 if isdeb; then
716 dir=/etc/gdm3
717 elif isfedora; then
718 # fedora didn\'t have the 3.
719 dir=/etc/gdm
720 fi
721 s mkdir -p $dir/PostLogin
722 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
723 s mkdir /etc/lightdm/lightdm.conf.d
724 s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
725 [SeatDefaults]
726 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
727 EOF
728 fi
729
730
731 pi ghc sakura
732 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
733
734 # use the package manger version to install the cabal version
735 pi cabal-install
736 cabal update
737 PATH="$PATH:$HOME/.cabal/bin"
738
739 # todo, on older ubuntu I used cabal xmonad + xfce,
740 # see /a/bin/old-unused/xmonad-cabal.sh
741
742 # trying out the distros versions newer distros
743 pi xmonad
744 if isarch; then
745 # for displaying error messages.
746 # optional dependency in arch, standard elsewhere.
747 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
748
749 # https://wiki.archlinux.org/index.php/Xinitrc
750 for homedir in /home/*; do
751 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
752 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
753 tee -a $homedir/.xinitrc <<'EOF'
754 /a/bin/desktop-20-autostart.sh
755 xsetroot -cursor_name left_ptr
756 exec xmonad
757 EOF
758 done
759 else
760 pi suckless-tools
761 fi
762 pi dmenu
763
764 if isdeb && (tp || x2); then
765 pi task-laptop
766 fi
767 fi
768
769 # the first pup command can kill off our /etc/ mod, so rerun this
770 /a/exe/ssh-emacs-setup
771 echo "$0: $(date): ending now"